#ifndef _SAMPLER_
#define _SAMPLER_
#include "mbed.h"
#include "LCD.hpp"
#include "SerialComms.hpp"
#include "sample_hardware.hpp"
#include "SDcard.hpp"
#define Activate_Flag 1

class Sampler
{
private:
    
public: 
    EventQueue SAMP_Queue;                  //Initialise the EventQueue

    void publishSample()
    {
        sample_message message = getData();
        m_oDisplay.LCD_Queue.call(&m_oDisplay, &LCD_Data::update_sensor_info, message); //Send sensor information to LCD via putting update_sensor_info function onto LCD queue with structure as input
        m_oSerial.SERIAL_Queue.call(&m_oSerial, &Serialcomms::setsampledata, message);  //Send sensor information to Serial via putting setsampledata function onto Serial queue with structure as input
        m_oNet.Network_Queue.call(&m_oNet, &Network::update_sensor_info, message);  //Send sensor information to Network via putting update_sensor_info function onto Network queue with structure as input
        m_oSD.SDcard_Queue.call(&m_oSD, &SDcard::update_sensor_info, message);  //Send sensor information to SD card via putting update_sensor_info function onto SD card queue with structure as input
    }
    
    sample_message getData()
    {       
        float temp = sensor.getTemperature();
        float pressure = sensor.getPressure();
        float LDR = adcIn.read()*4095;
        #ifdef BME
        float humidity = sensor.getHumidity();
        #endif
        sample_message msg; // Define instance of message structure
        msg.temp = temp;
        msg.pressure = pressure;
        msg.ldr = LDR;
        return msg;
    }
    
    void updateTimeData();

    Sampler()   //Constructor 
    {
    }
    ~Sampler() //Destructor - should the instance go out of scope, this is called
    {
    }
};
#endif